(load "functio.ss")
(define (search from to links) 
  (letrec ((result '())
        (first (lambda (ls) (car ls)))
        (second (lambda (ls) (cadr ls)))
        (third (lambda (ls) (caddr ls)))
        (compare (lambda (x y) (< (first x) (first y))))
        (accumulate-result (lambda (cost path) 
            (set! result (cons 
                          (list cost (reverse (cons to path))) 
                          result))))
        (search-step (lambda (from path cost links)
                       (iter from path cost links '())))
        (iter (lambda (from path cost unprocessed processed)
                (if (equal? from to)
                    (accumulate-result cost path)
                    (if (not (null? unprocessed))
                        (let* ((item (car unprocessed)) 
                               (links (append (cdr unprocessed) processed))
                               (new-cost (+ cost (third item))))
                          (cond ((equal? (first item) from)
                                 (search-step (second item) (cons from path) new-cost links ))
                                ((equal? (second item) from)
                                 (search-step (first item) (cons from path) new-cost links )))
                          (iter from path cost(cdr unprocessed) (cons item processed))))))))
    (search-step from '() 0.0 links)
    (quicksort result compare)))

(define (run filename) 
  (letrec ((port (open-input-file filename))
         (from (read port))
         (to (read port))
         (links (read port))
         (round2 (lambda (x) (/ (round (* x 100)) 100)))
         (round2-pr (lambda (pr) (cons (round2 (car pr)) (cdr pr))))
         (round2-ls (lambda (ls)
           (if (null? ls)
               ls
               (cons (round2-pr (car ls)) (round2-ls (cdr ls)))))))
    (close-input-port port)
    (round2-ls (search from to links))))
               
(run "s-input.txt")
